--Runekeeper Module

import "Turbine.Gameplay.Attributes"
WatchList={
--	Text that identifies the bar, Event that procs the bar, Name of bar, Function to run when proc'd
	{"n","AttunementChanged","Attunement Changed",function( sender, args )	numericprocupdate() end}}

--set flag to say there is a numeric component... Attunement here.
numeric=true
	
--Special updater for numeric bars
--Each of these is, sadly, unique to the class.
function numericprocupdate()
	local attunement=PlayerAttributes:GetAttunement()
	for i=1,#Bar do
		if type(Bar[i].Data.proc)=="number" then
			local level=Bar[i].Data.proc
			if level<10 then --this is a "harm" bar.
				if attunement<=level then Bar[i].Proc=true Bar[i]:Show() else Bar[i].Proc=false Bar[i]:Hide() end
			end
			if level>10 then --this is a "heal" bar
				if level<=attunement then Bar[i].Proc=true Bar[i]:Show() else Bar[i].Proc=false Bar[i]:Hide() end
			end 
			if level==10 then  --this is a "neutral only" bar
				if attunement==10 then Bar[i]:Show() else Bar[i]:Hide() end
			end
		end
	end
end

--Adds the option for the numeric procs.
--Again, sadly, unique.
function numericoption(self,contextMenu,contextMenuItems)
	for i=1,19 do
		local text=i..") "
		local level=self.Data.proc or 20
		local val=false

		if i<10 then
			text=text.."Harm " .. 10-i .. " or better"
			if level <10 and i<=level then val=true end
		end
		
		if i==10 then
			text=text.."Exactly Neutral"
			if level==10 then val=true end
		end
		
		if i>10 then 
			text=text.."Heal ".. i-10 .." or better"
			if level>10 and i>=level then val=true end
		end
	
		procMenu[100+i] = Turbine.UI.MenuItem( text,true,val );
		procMenu[100+i].Click = function( sender, args )
				for j=1,19 do
					procMenu[100+j]:SetChecked(false)
				end
				
				if i==10 then procMenu[100+10]:SetChecked(true) end
				if i<10 then 
					for j=i,9 do
						procMenu[100+j]:SetChecked(true)
					end
				end
				if i>10 then
					for j=11,i do
						procMenu[100+j]:SetChecked(true)
					end
				end
			self.Data.proc=i
			procupdate()
		end

		contextMenu.procs:Add(procMenu[100+i])
	end
	--Option to clear the flag.
	procMenu[101+20] = Turbine.UI.MenuItem( "Show in all attunements");
		procMenu[101+20].Click = function( sender, args )
			for j=1,19 do
				procMenu[100+j]:SetChecked(false)
			end
			self.Data.proc=nil
			procupdate()
		end
	contextMenu.procs:Add(procMenu[101+20])
end

import "JackdawPlugins.Bevy2.Proc"


--Table to use in Proc.Lua for the NewOption frame.
NumericProc={}

for i=1,19 do
	local text=i..") "
	
	if i<10 then
		text=text.."Harm " .. 10-i .. " or better"
	end
	
	if i==10 then
		text=text.."Exactly Neutral"
	end
	
	if i>10 then 
		text=text.."Heal ".. i-10 .." or better"
	end
	
	NumericProc[i]={}
	NumericProc[i][1]=text
	NumericProc[i][2]=i
end